-- File automatically generated by HDL Generator
-- http://arch.icte.uowm.gr
-- Date: 2014-04-13 17:25
-- Author: (c) 2013

library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;


ENTITY mul2_4_1_tb IS
END mul2_4_1_tb;

ARCHITECTURE behavior of mul2_4_1_tb IS

--- function vhdl_input_generator()

COMPONENT mul2_4_1 is
port (
in0:in STD_LOGIC_VECTOR(3 downto 0);
in1:in STD_LOGIC_VECTOR(1 downto 0);
in100:in STD_LOGIC;
in101:in STD_LOGIC;
--- end function vhdl_input_generator()
--- function vhdl_output_generator()
out0:out STD_LOGIC_VECTOR(5 downto 0) 
);
end COMPONENT;
--- end funcion vhdl_output_generator()
signal signal0: STD_LOGIC_VECTOR(3 downto 0);
signal signal1: STD_LOGIC_VECTOR(1 downto 0);
signal signal2: STD_LOGIC;
signal signal3: STD_LOGIC;
signal signal4: STD_LOGIC_VECTOR(5 downto 0);

constant clk_period : time := 1 ns;
signal clk : std_logic := '0';
signal reset : std_logic := '0';
-- Function vhdl_vec2int()
function vec2int (vec1: std_logic_vector) return integer is
variable retval: integer := 0;
alias vec: std_logic_vector(vec1'length-1 downto 0) is vec1;
begin
	for i in vec'high downto 1 loop
	if (vec(i)='1') then
		retval:=(retval+1)*2;
	else retval:=retval*2;
	end if;
end loop;

if (vec(0)='1') then 
	retval:=retval+1;
end if;

return retval;
end vec2int;
-- End function vhdl_vec2int()

BEGIN
-- Instantiate the Unit Under Test (UUT)
uut: mul2_4_1 PORT MAP (
signal0,
signal1,
signal2,
signal3,
signal4);


-- Clock process definitions( clock with 50% duty cycle is generated here.)
clk_process :process
begin
	clk <= '0';
	wait for clk_period/2;  --for 0.5 ns signal is '0'.
	clk <= '1';
	wait for clk_period/2;  --for next 0.5 ns signal is '1'.
end process;

stimulus_proc: process
variable waittime: integer := 10;
	begin
	--wait for waittime * 1 ns;
	--Perform any signal assigments here
	--e.g. signal0<='0';
	--
	--
-- function generate Standard Multiplier signals for testbench
waittime:= 12;
if(clk'event and clk='1') then
-- input vector: 8
signal0<="1000" AFTER  6 ns ;
-- input vector: 2
signal1<="10" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 16
assert (vec2int(signal4) = 16  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(16) severity error ;
assert (vec2int(signal4) /= 16  ) report "TESTBENCH OK" severity note ;
-- input vector: 2
signal0<="0010" AFTER  6 ns ;
-- input vector: 1
signal1<="01" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 2
assert (vec2int(signal4) = 2  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(2) severity error ;
assert (vec2int(signal4) /= 2  ) report "TESTBENCH OK" severity note ;
-- input vector: 9
signal0<="1001" AFTER  6 ns ;
-- input vector: 2
signal1<="10" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 18
assert (vec2int(signal4) = 18  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(18) severity error ;
assert (vec2int(signal4) /= 18  ) report "TESTBENCH OK" severity note ;
-- input vector: 7
signal0<="0111" AFTER  6 ns ;
-- input vector: 0
signal1<="00" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal4) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal4) /= 0  ) report "TESTBENCH OK" severity note ;
-- input vector: 7
signal0<="0111" AFTER  6 ns ;
-- input vector: 0
signal1<="00" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal4) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal4) /= 0  ) report "TESTBENCH OK" severity note ;
-- input vector: 10
signal0<="1010" AFTER  6 ns ;
-- input vector: 2
signal1<="10" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 20
assert (vec2int(signal4) = 20  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(20) severity error ;
assert (vec2int(signal4) /= 20  ) report "TESTBENCH OK" severity note ;
-- input vector: 12
signal0<="1100" AFTER  6 ns ;
-- input vector: 2
signal1<="10" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 24
assert (vec2int(signal4) = 24  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(24) severity error ;
assert (vec2int(signal4) /= 24  ) report "TESTBENCH OK" severity note ;
-- input vector: 13
signal0<="1101" AFTER  6 ns ;
-- input vector: 1
signal1<="01" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 13
assert (vec2int(signal4) = 13  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(13) severity error ;
assert (vec2int(signal4) /= 13  ) report "TESTBENCH OK" severity note ;
-- input vector: 0
signal0<="0000" AFTER  6 ns ;
-- input vector: 2
signal1<="10" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal4) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal4) /= 0  ) report "TESTBENCH OK" severity note ;
-- input vector: 10
signal0<="1010" AFTER  6 ns ;
-- input vector: 2
signal1<="10" AFTER  6 ns ;
wait for waittime * 1 ns ;
-- output: 20
assert (vec2int(signal4) = 20  ) report "TESTBENCH Output:"&integer'image(vec2int(signal4))&" Expected:"&integer'image(20) severity error ;
assert (vec2int(signal4) /= 20  ) report "TESTBENCH OK" severity note ;
assert false report "End of Testbench. Stopping Simulation" severity failure;


--function create_postample_process_for_testbench
end if;
--
wait on clk;
end process;
signal2<=clk;
signal3<='0';
-- end function create_postample_process_for_testbench
-- end function generating signals for testbench
END;
