-- File automatically generated by HDL Generator
-- http://arch.icte.uowm.gr
-- Date: 2014-04-13 17:33
-- Author: (c) 2013

library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;


ENTITY mul32_32_0_tb IS
END mul32_32_0_tb;

ARCHITECTURE behavior of mul32_32_0_tb IS

--- function vhdl_input_generator()

COMPONENT mul32_32_0 is
port (
in0:in STD_LOGIC_VECTOR(31 downto 0);
in1:in STD_LOGIC_VECTOR(31 downto 0);
--- end function vhdl_input_generator()
--- function vhdl_output_generator()
out0:out STD_LOGIC_VECTOR(64 downto 0) 
);
end COMPONENT;
--- end funcion vhdl_output_generator()
signal signal0: STD_LOGIC_VECTOR(31 downto 0);
signal signal1: STD_LOGIC_VECTOR(31 downto 0);
signal signal2: STD_LOGIC_VECTOR(64 downto 0);

constant clk_period : time := 1 ns;
signal clk : std_logic := '0';
signal reset : std_logic := '0';
-- Function vhdl_vec2int()
function vec2int (vec1: std_logic_vector) return integer is
variable retval: integer := 0;
alias vec: std_logic_vector(vec1'length-1 downto 0) is vec1;
begin
	for i in vec'high downto 1 loop
	if (vec(i)='1') then
		retval:=(retval+1)*2;
	else retval:=retval*2;
	end if;
end loop;

if (vec(0)='1') then 
	retval:=retval+1;
end if;

return retval;
end vec2int;
-- End function vhdl_vec2int()

BEGIN
-- Instantiate the Unit Under Test (UUT)
uut: mul32_32_0 PORT MAP (
signal0,
signal1,
signal2);


-- Clock process definitions( clock with 50% duty cycle is generated here.)
clk_process :process
begin
	clk <= '0';
	wait for clk_period/2;  --for 0.5 ns signal is '0'.
	clk <= '1';
	wait for clk_period/2;  --for next 0.5 ns signal is '1'.
end process;

stimulus_proc: process
variable waittime: integer := 10;
	begin
	--wait for waittime * 1 ns;
	--Perform any signal assigments here
	--e.g. signal0<='0';
	--
	--
-- function generate Standard Multiplier signals for testbench
waittime:= 130;
-- input vector: 667662315
signal0<="00100111110010111011011111101011" AFTER  65 ns ;
-- input vector: 3184848532
signal1<="10111101110101001110111010010100" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 2126403343799471580
assert (vec2int(signal2) = 2126403343799471580  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(2126403343799471580) severity error ;
assert (vec2int(signal2) /= 2126403343799471580  ) report "TESTBENCH OK" severity note ;
-- input vector: 3858401722
signal0<="11100101111110101000100110111010" AFTER  65 ns ;
-- input vector: 3276164387
signal1<="11000011010001100100110100100011" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 12640758312355874414
assert (vec2int(signal2) = 12640758312355874414  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(12640758312355874414) severity error ;
assert (vec2int(signal2) /= 12640758312355874414  ) report "TESTBENCH OK" severity note ;
-- input vector: 3219709186
signal0<="10111111111010001101110100000010" AFTER  65 ns ;
-- input vector: 3961552928
signal1<="11101100001000001000000000100000" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 12755048353106796608
assert (vec2int(signal2) = 12755048353106796608  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(12755048353106796608) severity error ;
assert (vec2int(signal2) /= 12755048353106796608  ) report "TESTBENCH OK" severity note ;
-- input vector: 283774383
signal0<="00010000111010100000110110101111" AFTER  65 ns ;
-- input vector: 1805579100
signal1<="01101011100111101111001101011100" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 512377095060195300
assert (vec2int(signal2) = 512377095060195300  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(512377095060195300) severity error ;
assert (vec2int(signal2) /= 512377095060195300  ) report "TESTBENCH OK" severity note ;
-- input vector: 4288326582
signal0<="11111111100110101010101110110110" AFTER  65 ns ;
-- input vector: 1004019325
signal1<="00111011110110000001111001111101" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 4305562760239197150
assert (vec2int(signal2) = 4305562760239197150  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(4305562760239197150) severity error ;
assert (vec2int(signal2) /= 4305562760239197150  ) report "TESTBENCH OK" severity note ;
-- input vector: 2575386826
signal0<="10011001100000010100100011001010" AFTER  65 ns ;
-- input vector: 2529010138
signal1<="10010110101111011010000111011010" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 6513179392225641988
assert (vec2int(signal2) = 6513179392225641988  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(6513179392225641988) severity error ;
assert (vec2int(signal2) /= 6513179392225641988  ) report "TESTBENCH OK" severity note ;
-- input vector: 2360023255
signal0<="10001100101010110001100011010111" AFTER  65 ns ;
-- input vector: 4015715737
signal1<="11101111010110101111010110011001" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 9477182524789463935
assert (vec2int(signal2) = 9477182524789463935  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(9477182524789463935) severity error ;
assert (vec2int(signal2) /= 9477182524789463935  ) report "TESTBENCH OK" severity note ;
-- input vector: 1705462068
signal0<="01100101101001110100100100110100" AFTER  65 ns ;
-- input vector: 3725179748
signal1<="11011110000010011011101101100100" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 6353152756695798864
assert (vec2int(signal2) = 6353152756695798864  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(6353152756695798864) severity error ;
assert (vec2int(signal2) /= 6353152756695798864  ) report "TESTBENCH OK" severity note ;
-- input vector: 3341100827
signal0<="11000111001001010010011100011011" AFTER  65 ns ;
-- input vector: 903431499
signal1<="00110101110110010100010101001011" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 3018455728446749673
assert (vec2int(signal2) = 3018455728446749673  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(3018455728446749673) severity error ;
assert (vec2int(signal2) /= 3018455728446749673  ) report "TESTBENCH OK" severity note ;
-- input vector: 2101943550
signal0<="01111101010010010001110011111110" AFTER  65 ns ;
-- input vector: 1708085923
signal1<="01100101110011110101001010100011" AFTER  65 ns ;
wait for waittime * 1 ns ;
-- output: 3590300188695646650
assert (vec2int(signal2) = 3590300188695646650  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(3590300188695646650) severity error ;
assert (vec2int(signal2) /= 3590300188695646650  ) report "TESTBENCH OK" severity note ;
assert false report "End of Testbench. Stopping Simulation" severity failure;


--function create_postample_process_for_testbench
end process;
-- end function create_postample_process_for_testbench
-- end function generating signals for testbench
END;
