-- File automatically generated by HDL Generator
-- http://arch.icte.uowm.gr
-- Date: 2014-04-13 17:26
-- Author: (c) 2013

library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;


ENTITY mul4_4_0_tb IS
END mul4_4_0_tb;

ARCHITECTURE behavior of mul4_4_0_tb IS

--- function vhdl_input_generator()

COMPONENT mul4_4_0 is
port (
in0:in STD_LOGIC_VECTOR(3 downto 0);
in1:in STD_LOGIC_VECTOR(3 downto 0);
--- end function vhdl_input_generator()
--- function vhdl_output_generator()
out0:out STD_LOGIC_VECTOR(7 downto 0) 
);
end COMPONENT;
--- end funcion vhdl_output_generator()
signal signal0: STD_LOGIC_VECTOR(3 downto 0);
signal signal1: STD_LOGIC_VECTOR(3 downto 0);
signal signal2: STD_LOGIC_VECTOR(7 downto 0);

constant clk_period : time := 1 ns;
signal clk : std_logic := '0';
signal reset : std_logic := '0';
-- Function vhdl_vec2int()
function vec2int (vec1: std_logic_vector) return integer is
variable retval: integer := 0;
alias vec: std_logic_vector(vec1'length-1 downto 0) is vec1;
begin
	for i in vec'high downto 1 loop
	if (vec(i)='1') then
		retval:=(retval+1)*2;
	else retval:=retval*2;
	end if;
end loop;

if (vec(0)='1') then 
	retval:=retval+1;
end if;

return retval;
end vec2int;
-- End function vhdl_vec2int()

BEGIN
-- Instantiate the Unit Under Test (UUT)
uut: mul4_4_0 PORT MAP (
signal0,
signal1,
signal2);


-- Clock process definitions( clock with 50% duty cycle is generated here.)
clk_process :process
begin
	clk <= '0';
	wait for clk_period/2;  --for 0.5 ns signal is '0'.
	clk <= '1';
	wait for clk_period/2;  --for next 0.5 ns signal is '1'.
end process;

stimulus_proc: process
variable waittime: integer := 10;
	begin
	--wait for waittime * 1 ns;
	--Perform any signal assigments here
	--e.g. signal0<='0';
	--
	--
-- function generate Standard Multiplier signals for testbench
waittime:= 16;
-- input vector: 3
signal0<="0011" AFTER  8 ns ;
-- input vector: 12
signal1<="1100" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 36
assert (vec2int(signal2) = 36  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(36) severity error ;
assert (vec2int(signal2) /= 36  ) report "TESTBENCH OK" severity note ;
-- input vector: 4
signal0<="0100" AFTER  8 ns ;
-- input vector: 6
signal1<="0110" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 24
assert (vec2int(signal2) = 24  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(24) severity error ;
assert (vec2int(signal2) /= 24  ) report "TESTBENCH OK" severity note ;
-- input vector: 9
signal0<="1001" AFTER  8 ns ;
-- input vector: 0
signal1<="0000" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal2) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal2) /= 0  ) report "TESTBENCH OK" severity note ;
-- input vector: 12
signal0<="1100" AFTER  8 ns ;
-- input vector: 0
signal1<="0000" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal2) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal2) /= 0  ) report "TESTBENCH OK" severity note ;
-- input vector: 4
signal0<="0100" AFTER  8 ns ;
-- input vector: 7
signal1<="0111" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 28
assert (vec2int(signal2) = 28  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(28) severity error ;
assert (vec2int(signal2) /= 28  ) report "TESTBENCH OK" severity note ;
-- input vector: 0
signal0<="0000" AFTER  8 ns ;
-- input vector: 4
signal1<="0100" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal2) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal2) /= 0  ) report "TESTBENCH OK" severity note ;
-- input vector: 6
signal0<="0110" AFTER  8 ns ;
-- input vector: 3
signal1<="0011" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 18
assert (vec2int(signal2) = 18  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(18) severity error ;
assert (vec2int(signal2) /= 18  ) report "TESTBENCH OK" severity note ;
-- input vector: 5
signal0<="0101" AFTER  8 ns ;
-- input vector: 6
signal1<="0110" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 30
assert (vec2int(signal2) = 30  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(30) severity error ;
assert (vec2int(signal2) /= 30  ) report "TESTBENCH OK" severity note ;
-- input vector: 11
signal0<="1011" AFTER  8 ns ;
-- input vector: 6
signal1<="0110" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 66
assert (vec2int(signal2) = 66  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(66) severity error ;
assert (vec2int(signal2) /= 66  ) report "TESTBENCH OK" severity note ;
-- input vector: 14
signal0<="1110" AFTER  8 ns ;
-- input vector: 0
signal1<="0000" AFTER  8 ns ;
wait for waittime * 1 ns ;
-- output: 0
assert (vec2int(signal2) = 0  ) report "TESTBENCH Output:"&integer'image(vec2int(signal2))&" Expected:"&integer'image(0) severity error ;
assert (vec2int(signal2) /= 0  ) report "TESTBENCH OK" severity note ;
assert false report "End of Testbench. Stopping Simulation" severity failure;


--function create_postample_process_for_testbench
end process;
-- end function create_postample_process_for_testbench
-- end function generating signals for testbench
END;
